#
# Efeito de Fade In e Out com PWM e Raspberry Pi
#
# Autora: Ana Paula Messina - anamessina.apm@gmail.com
# Data: 30/04/2019
# --------------------------------------------------------------------

import RPi.GPIO as GPIO
from guizero import App, Slider, Text

# Configuração da GPIO
pino_pwn = 20

# Calibragem da tensão GPIO nível HIGH (utilizar multímetro)
tensao_gpio = 3.3

freq = 100  # Hz
duty = 0    # %

GPIO.setmode(GPIO.BCM)
GPIO.setup(pino_pwn, GPIO.OUT)

pwm = GPIO.PWM(pino_pwn, freq)
pwm.start(duty)

def pwm_led(valor_slider):
    duty = int(valor_slider)
    pwm.ChangeDutyCycle(duty)
    tensao_media = (tensao_gpio * duty) / 100
    t_tensao.value = tensao_media

app = App(title="PWM LED | Fade", bg="#f5f5f5", height=150, width=400)

Text(app, text="Duty Cycle (%)", font="Arial", size=15, color="#000000")

Slider(app, command=pwm_led, start=0, end=100, width=200, height=50)
Text(app, text="Tensão média GPIO (V)", font="Arial", size=15, color="#000000",)
t_tensao = Text(app, text="0.0", font="Arial", size=13, color="#000000", )

try:
    app.display()
except KeyboardInterrupt:
    pass
pwm.stop()
GPIO.cleanup()